﻿var SideMenu = function (element, options) {
    this.element = $(element);
    this.options = $.extend(true, {}, this.options, options);
    this.init();

}
SideMenu.prototype = {

    options: {
        beforeOpenIndex: null,
        collapse: false
    },

    init: function () {
        var me = this,
            el = me.element,
            opts = me.options;

        if (!opts.data) opts.data = [];
        el.addClass("sidemenu");

        if (opts.collapse) {
            el.addClass("sidemenu-collapsed")
        }



        me._createSideIcons();
        me._createSideItems();
        me._createMenuCollapse();

        $(".sidemenu-items").on("scroll", function () {
            var left = $(".sidemenu-items")[0].scrollTop;

            $(".sidemenu-icons").scrollTop(left);
        });


        el.on("click", function (event) {

            var sideCollapse = $(event.target).closest('.collapse-icons');

            //折叠按钮
            if (sideCollapse[0]) {
                me._collapseMenu();
            }

            var itemEl = $(event.target).closest('.sidemenu-item-title')[0];

            //itemclick
            if (itemEl) {
                var item = me.getItemById(itemEl.id);
                if (me.options.itemclick) me.options.itemclick(item);
            }


            //打开子元素,ul li的查找很烦
            var openEl = $(event.target).closest('.sidemenu-items>ul>.sidemenu-item>.sidemenu-item-title');

            if (openEl[0]) {
                me._openMenu(openEl);
                me._closeBeforeMenu(openEl);

            }
        });

    },

    getItemById: function (id) {
        var me = this,
            data = me.options.data,
            found;

        function each(items) {
            if (found) return;
            for (var i = 0, l = items.length; i < l; i++) {
                var item = items[i];
                if (!found && item.id == id) {
                    found = item;
                    break;
                }
                if (item.children) each(item.children);
            }
        }
        each(data);

        return found;
    },

    _createSideIcons: function () {
        var me = this,
            el = me.element,
            opts = me.options,
            data = opts.data;
        var sb = [];
        sb[sb.length] = '<div class="sidemenu-icons">'

        for (var i = 0; i < data.length; i++) {
            sb[sb.length] = '<div class="sidemenu-icon">'
            sb[sb.length] = '<div class="sidemenu-icon-border">'
            sb[sb.length] = '<div class="icon" id="' + data[i].id + '">'
            sb[sb.length] = ' <div class="sidemenu-icon-tip">'
            sb[sb.length] = data[i].text
            sb[sb.length] = '</div>'
            sb[sb.length] = ' </div>'
            sb[sb.length] = ' </div>'
            sb[sb.length] = ' </div>'
        }
        el.append(sb.join(""));
    },

    _createSideItems: function () {
        var me = this,
            el = me.element,
            opts = me.options;

        var sb = [];
        sb[sb.length] = '<div class="sidemenu-items">'
        this._createItems(sb, opts.data);
        sb[sb.length] = ' </div>'

        el.append(sb.join(""));
    },

    _createItems: function (sb, items) {
        var me = this;

        sb[sb.length] = '<ul>'
        for (var i = 0; i < items.length; i++) {
            var item = items[i];

            sb[sb.length] = '<li class="sidemenu-item">'

            sb[sb.length] = '<div class="sidemenu-item-title" id=' + item.id + '>'
            //icon, text, expander

            if (me.options.itemRenderer) {
                sb[sb.length] = me.options.itemRenderer(item);
            } else {
                sb[sb.length] = item.text;
            }

            sb[sb.length] = '</div>';

            if (item.children && item.children.length > 0) {
                me._createItems(sb, item.children);
            }

            sb[sb.length] = '</li>';
        }
        sb[sb.length] = ' </ul>'

    },
    _createMenuCollapse: function () {

        var me = this,
            el = me.element;
        var sb = [];
        sb[sb.length] = '<div class="collapse-icons">'
        sb[sb.length] = '<div class="icon collapse-icon"></div>'
        sb[sb.length] = ' </div>'
        sb[sb.length] = ' </div>'

        el.append(sb.join(""));
    },

    _collapseMenu: function () {
        $(".sidemenu").toggleClass("sidemenu-collapsed");
    },

    _openMenu: function (openEl) {

        var me = this;
        var parentEl = $(openEl).parent();
        parentEl.toggleClass("open");

        var index = parentEl.index();

        var thisElHeight = parentEl[0].offsetHeight;

        var sibEl = $(".sidemenu-icons").children().eq(index);

        sibEl.css("height", thisElHeight);
        sibEl.addClass("active");


    },
    _closeBeforeMenu: function (openEl) {

        var me = this;
        var opts = me.options;
        var parentEl = $(openEl).parent();
        var index = parentEl.index();
        var beforeOpenIndex = opts.beforeOpenIndex;

        
        if (beforeOpenIndex != null) {

            $(".sidemenu-icons").children().eq(beforeOpenIndex).removeClass("active");
            if (beforeOpenIndex != index) {
                var beforeSibEl = $(".sidemenu-items").children()[0].children[beforeOpenIndex];
                $(beforeSibEl).removeClass("open");
                $(".sidemenu-icons").children().eq(beforeOpenIndex).css("height", 50);
            }
        }
        if (beforeOpenIndex == index) {


        }
        opts.beforeOpenIndex = index;
    }
}

$.fn.sidemenu = function (options) {

    var isSTR = typeof options == "string",
        args, ret;

    if (isSTR) {
        args = $.makeArray(arguments)
        args.splice(0, 1);
    }

    var name = "sidemenu",
        type = SideMenu;

    var jq = this.each(function () {
        var ui = $.data(this, name);

        if (!ui) {
            ui = new type(this, options);
            $.data(this, name, ui);
        }
        if (isSTR) {
            ret = ui[options].apply(ui, args);
        }
    });

    return isSTR ? ret : jq;
};


//var SideMenuX = function(){
//};

//SideMenuX.prototype = new SideMenu();

//SideMenuX.prototype._openMenu = function(){
//}

